#!/usr/bin/perl -w

use warnings;
use strict;
use IO::Socket::INET;
use MIME::Base64;
use Compress::Zlib;

our $bufsize=7000;
our $zlevel=9;
our $debug=1;
our $ua="Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 6.1; WOW64; Trident/4.0; SLCC2; .NET CLR 2.0.50727; InfoPath.2)";

die "Use:\n$0 local_ip:local_port http://localhost/server.php [tunnel_ip:tuneel_port]\n" if $#ARGV<1 || $ARGV[0]!~ /^(\d+\.){3}\d+:\d+$/ || $ARGV[1]!~ /^https?:\/\/([^\/]+)(.*)$/;
$|=1;
$SIG{'CHLD'} = 'IGNORE';
our $suse;
our $whost=$1;
our $wpath=$2;
our ($tport,$thost);
our $ssl=1 if $ARGV[1]=~ /^https/;

die('plz install "IO::Socket::SSL" module') if defined $ssl && !eval 'require IO::Socket::SSL;';

if($ARGV[2] && $ARGV[2]=~ /^((\d+\.){3}\d+):(\d+)$/){
$suse=1;
$thost=$1;
$tport=$3;
}

my $bind = IO::Socket::INET->new(Listen=>10, LocalAddr=>$ARGV[0], ReuseAddr=>1) or die "Could not bind to ".$ARGV[0]."\n";
our $client;
while($client = $bind->accept()) {
 $client->autoflush();
 if(fork()){ $client->close(); }
 else { $bind->close(); ($suse?socks_connect($client,$thost,$tport,''):new_client($client)); exit(); }
}

sub new_client {
	my($t, $i, $buff, $ord, $success);
	my $client = $_[0];
	sysread($client, $buff, 1);
	if(ord($buff) != 5) { return; } #must be SOCKS5
	sysread($client, $buff, 1);
	$t=ord($buff);
	unless(sysread($client, $buff, $t) == $t) { return; }

	$success=0;
	for($i=0; $i < $t; $i++) {
	 $ord = ord(substr($buff, $i, 1));
	 if($ord == 0 ) {
	   syswrite($client, "\x05\x00", 2);
	   $success++;
	   last;
	 }
	}
	if($success) {
	 $t = sysread($client, $buff, 3);

	 if(substr($buff, 0, 1) eq "\x05") {
	   if(ord(substr($buff, 2, 1)) == 0) { # reserved
		 my($host, $raw_host) = socks_get_host($client);
		 if(!$host) { return; }
		 my($port, $raw_port) = socks_get_port($client);
		 if(!$port) { return; }
		 $ord = ord(substr($buff, 1, 1));
		 $buff = "\x00".$raw_host.$raw_port;
		 socks_connect($client, $host, $port, $buff) if $ord==1;
	   }
	 }
	}
	else { syswrite($client, "\x05\xFF", 2); }
	$client->close();
}

sub socks_get_host {
 my $client = $_[0];
 my ($t, $ord, $raw_host);
 my $host = "";
 my @host;
  sysread($client, $t, 1);
 $ord = ord($t);
 if($ord == 1) {
   sysread($client, $raw_host, 4);
   $host = ord(substr($raw_host,0,1)).".".ord(substr($raw_host,1,1)).".".ord(substr($raw_host,2,1)).".".ord(substr($raw_host,3,1));
 } elsif($ord == 3) {
   sysread($client, $raw_host, 1);
   sysread($client, $host, ord($raw_host));
   $raw_host .= $host;
 }
return ($host, $t.$raw_host);
}

sub socks_get_port {
 my $client = $_[0];
 my ($raw_port, $port);
 sysread($client, $raw_port, 2);
 $port = ord(substr($raw_port, 0, 1)) << 8 | ord(substr($raw_port, 1, 1));
 return ($port, $raw_port);
}

sub socks_connect {
my($client, $host, $port, $buff) = @_;
print "$ARGV[0] => $host:$port" if $debug;

my $target = eval 'IO::Socket::'.((defined $ssl)?"SSL":"INET").'->new(PeerAddr => "$whost:'.((defined $ssl)?443:80).'", @_) or die "connect error for $!"';
print $target "GET $wpath HTTP/1.1
Host: $whost
User-Agent: $ua
Cookie: a=c; d=$host:$port; \r\n\r\n";

my ($ident,$data,$in,$result);
my $c=0;

while (1) {
	sysread($target,$data,1) or die "Read error $!";
	$in.=$data;
	#print $data if $debug;
	if($in=~ m/ident:(.+)\n$/){ $ident=$1; last}
	if($in=~ m/<ERR>(.*)<\/ERR>\n$/)
		{
			syswrite($client, "\x05\x04".$buff) if !$suse;
			print "\tSTATUS: $1.\n" if $debug;
			exit;
		}
	die "\tIDENT NOT FOUND\n" if ++$c>4096;
}
syswrite($client, "\x05\x00".$buff) if !$suse;
print "\tSTATUS: OK\n" if $debug;

unless($target) { return; }
	$target->autoflush();

my ($clres,$trres);
 while($client && $target) {

   my $rin = "";
   vec($rin, fileno($client), 1) = 1 if $client;
   vec($rin, fileno($target), 1) = 1 if $target;
   my($rout, $eout);

   select($rout = $rin, undef, $eout = $rin, 120);
   if (!$rout  &&  !$eout) {return; }
   my $cbuffer = "";
   my $tbuffer = "";

   if ($client && (vec($eout, fileno($client), 1) || vec($rout, fileno($client), 1))) {
     $clres = sysread($client, $tbuffer, $bufsize);
     if (!defined($clres) || !$clres) {
		wsend("<MSG>DISCONNECT</MSG>",$ident);
		print "client DISCONNECTED\n" if $debug;
		return;
					}
	#open OUT,'>>./log.txt';
	#print OUT "SEND: ".$tbuffer if $debug;
	#close(OUT);
   }

   if ($target  &&  (vec($eout, fileno($target), 1)  || vec($rout, fileno($target), 1))) {
	$trres=wread($target,$ident);
	return if !defined $trres ;

   }


   if($clres){
	if(!wsend($tbuffer,$ident))	{
	print "target DISCONNECTED\n" if $debug;
	$client->shutdown(0);
	exit;
					}
    $clres=0;
   }

   if($trres){
    my $res = syswrite($client, $trres, length($trres));
    if (!defined($res) && $res ==0) { return; }
    $trres=0;
   }
 }
}


sub wsend
{
my ($data,$ident)=@_;
my $osock = eval 'IO::Socket::'.((defined $ssl)?"SSL":"INET").'->new(PeerAddr => "$whost:'.((defined $ssl)?443:80).'", @_) or die "connect error for $!"';
$data=comp($data);
$data=~ s/\+/%2B/g;
syswrite $osock, "GET $wpath HTTP/1.1
Host: $whost
User-Agent: $ua
Cookie: i=$ident;
Content-Type: application/x-www-form-urlencoded
Content-Length: ".length($data)."\r\n\r\n$data\r\n";
sysread $osock,$data,4096;
$osock->shutdown(1);
return ($data=~ /STATUS: OK/ )?1:0;
}

sub wread
{
my ($target,$ident)=@_;
my ($in,$cbuffer);

	while (1)
	{
		if((my $len=sysread($target,$cbuffer,1))==0)
			{
		print "Read error: $!, DISCONNECTED\n" if $debug;
		exit;
			}
		last if $cbuffer eq "\n";
		$in.=$cbuffer;
	}

#print "READ:".$in."\n";
	if($in=~ s/^d:(.+)/$1/)
	{
		if($in=~ /<MSG>DISCONNECT<\/MSG>/)
		{
		print "target DISCONNECTED\n" if $debug;
		close $client;
		return;
		}
#print "READ: ".decomp($in) if $debug;
	return decomp($in);
	}
	return '';
}

sub comp{
my $x = deflateInit(-Level =>$zlevel);
$x->deflate(shift);
return encode_base64($x->flush());
}

sub decomp{
return inflateInit(WindowBits => -&MAX_WBITS())->inflate(decode_base64(shift));
}

